/*		@(#)button.h	1.2 Stellar 89/03/22	*/
/*
			Copyright 1989 by
			Stellar Computer Inc.
			All Rights Reserved
	
	This software comprises unpublished confidential information of
	Stellar Computer Inc. and may not be used, copied or made
	available to anyone, except in accordance with the license
	under which it is furnished.
*/
/*
 * LUI Button header
 */

#ifndef _LUI_BUTTON_HEADER

#ifdef LUI_BUTTON_DECLARE
# define LUI_BUTTON_GLOBAL  /* */
# define LUI_BUTTON_INIT(v) = v
#else
# define LUI_BUTTON_GLOBAL  extern
# define LUI_BUTTON_INIT(v) /* */
#endif

#define LUI_BUTTON_YS             30  /*32 default*/
#define LUI_BUTTON_SMALL_XS       90
#define LUI_BUTTON_LARGE_XS       180
#define LUI_BUTTON_PIXMAP_SM_IN   "LUI_Button.PixmapSmallIn"
#define LUI_BUTTON_PIXMAP_SM_OUT  "LUI_Button.PixmapSmallOut"
#define LUI_BUTTON_PIXMAP_LG_IN   "LUI_Button.PixmapLargeIn"
#define LUI_BUTTON_PIXMAP_LG_OUT  "LUI_Button.PixmapLargeOut"

#define LUI_BUTTON_RADIO_PIXMAP_IN  "LUI_Button.Radio.In"
#define LUI_BUTTON_RADIO_PIXMAP_OUT "LUI_Button.Radio.Out"

#define LUI_BUTTON_OPTION_PIXMAP_IN "LUI_Button.Option.In"
#define LUI_BUTTON_OPTION_PIXMAP_OUT "LUI_Button.Option.Out"

#define LUI_BUTTON_SMALL       0
#define LUI_BUTTON_LARGE       1

#define LUI_BUTTON_OUT         0
#define LUI_BUTTON_IN          1

#define LUI_BUTTON_CONFIG     -1   /* Application changes label and redraws   */
#define LUI_BUTTON_TOGGLE      0   /* Toggle switch: on/off/on, etc           */
#define LUI_BUTTON_FUNCTION    1   /* Stays on until another function picked  */
#define LUI_BUTTON_ONESHOT     2   /* Immediately pops out after selecting    */
#define LUI_BUTTON_NODRAW      3   /* Button not drawn, state doesn't change  */

#define LUI_BUTTON_RADIO      10
#define LUI_BUTTON_OPTION     11

typedef struct lui_button {
    char           label[64];
    int            group;
    int            state;
    int            active;
    Window         window;
    int            type;
    int            x, y;
    int            width, height;
    int            index;
    unsigned int   hicolor; /* BEP 2-13-92 */
    int            ((*func)());
    Pixmap         pixmap_out, pixmap_in;
    XEvent        *event;
    struct lui_button_pad *button_pad;
    struct lui_button *np;
} LUI_BUTTON;

typedef struct lui_button_pad {
    char           name[64];
    Window         window;
    LUI_BUTTON    *button_head;
    int            type;
    int            x, y;
    int            width, height;
    int            border_size;
    int            visible, hiding;
    Pixmap         pixmap_out, pixmap_in;
    int            hue;
    unsigned long  background_color;
    struct lui_button_pad *np;
} LUI_BUTTON_PAD;

LUI_BUTTON_GLOBAL LUI_BUTTON_PAD 
  *LUI_ButtonPadHead LUI_BUTTON_INIT ( NULL ),
  *LUI_ButtonPad     LUI_BUTTON_INIT ( NULL );

LUI_BUTTON_GLOBAL int
  LUI_ButtonPadX, LUI_ButtonPadY, 
  LUI_ButtonPadWidth, LUI_ButtonPadHeight,
  LUI_Button_pad_width, LUI_Button_pad_height;

LUI_BUTTON_GLOBAL LUI_BUTTON 
  *LUI_ButtonHead;

LUI_BUTTON_GLOBAL Window 
  LUI_ButtonWindow;

LUI_BUTTON 
  *LUI_ButtonCreate(),
  *LUI_ButtonCreateType(),
  *LUI_ButtonLookupWindow(),
  *LUI_ButtonLookupName();

LUI_BUTTON_PAD 
  *LUI_ButtonPadOpen(),
  *LUI_ButtonPadOpenType(),
  *LUI_ButtonPadLookup();

#endif  _LUI_BUTTON_HEADER
#define _LUI_BUTTON_HEADER 1
